=== debian/changelog ===
yoshimi (1.5.6-3) unstable; urgency=medium

  * Add patch to fix FTBFS on hurd-i386. (Closes: #885249)
  * Set dh/compat 11.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 28 Dec 2017 19:29:49 +0100

yoshimi (1.5.6-2) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * d/control: mark yoshimi-data as Multi-Arch:foreign.

  [ Jaromír Mikeš ]
  * Update copyright file.
  * Deal with white spaces in file names - copyright file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Fri, 22 Dec 2017 01:54:44 +0100

yoshimi (1.5.6-1) unstable; urgency=medium

  * New upstream version 1.5.6
  * Patches refreshed/removed.
  * Bump Standards.
  * Introduce doc package.
  * Update overrides file.
  * Add doc-base file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 17 Dec 2017 14:49:27 +0100

yoshimi (1.5.5-2) unstable; urgency=medium

  * Add patch to fix build on non-linux systems.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 13 Dec 2017 01:06:45 +0100

yoshimi (1.5.5-1) unstable; urgency=medium

  * New upstream version 1.5.5
  * Use secure uri where possible.
  * Patch refreshed.
  * Add more entries to override file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 11 Dec 2017 22:29:45 +0100

yoshimi (1.5.4.1-1) unstable; urgency=medium

  * Update watch file to track github repo.
  * New upstream version 1.5.4.1
  * Remove compression bz2 from gbp.conf.
  * Bump Standards.
  * Install manual.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 17 Oct 2017 02:24:51 +0200

yoshimi (1.5.4-1) unstable; urgency=medium

  * New upstream version 1.5.4
  * Bump Standards.
  * Patches refreshed/deleted.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 02 Oct 2017 11:47:41 +0200
