=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export LV2_PATH = /usr/lib/lv2

%:
	dh $@ --sourcedirectory=src
