=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: yoshimi
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
@@ -25,9 +25,9 @@
  lv2-dev,
  sharutils,
  zlib1g-dev
-Standards-Version: 4.1.2
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/yoshimi.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-multimedia/yoshimi.git
+Standards-Version: 4.1.4
+Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi
 Homepage: https://yoshimi.sourceforge.io
 
 Package: yoshimi
@@ -64,6 +64,7 @@
 Package: yoshimi-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Recommends:
