## yoshimi 1.5.10.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #   CMakeLists.txt
 #
 #   Copyright 2009-2011, Alan Calvert
-#   Copyright 2014-2017, Will Godfrey & others
+#   Copyright 2014-2019, Will Godfrey & others
 #
 #   This file is part of yoshimi, which is free software: you can
 #   redistribute it and/or modify it under the terms of the GNU General
@@ -17,7 +17,7 @@
 #   You should have received a copy of the GNU General Public License
 #   along with yoshimi.  If not, see <http://www.gnu.org/licenses/>.
 
-# Modifed December 2017
+# Modified January 2019
 
 project (Yoshimi)
 cmake_minimum_required (VERSION 3.0)
@@ -25,16 +25,24 @@
 cmake_policy (SET CMP0004 NEW)
 if (POLICY CMP0046)
     cmake_policy (SET CMP0046 NEW)
-endif (POLICY CMP0046)
+endif (POLICY CMP0046) # opengl version
+if (POLICY CMP0072)
+    cmake_policy (SET CMP0072 OLD)
+endif (POLICY CMP0072)
 set (CMAKE_CXX_STANDARD 11) # we seem to need both for
 add_definitions(-std=gnu++11) # various versions of cmake
 
+add_definitions(-Wall)
+
 # vvv
-add_definitions(-Wall)
-add_definitions(-Werror=format-security)
+#add_definitions(-Wpedantic)
+#add_definitions(-Werror=format-security)
+#add_definitions(-Wextra)
 # ^^^ comment these out on release pushes
 
-set (YOSHIMI_VERSION "1.5.6")
+set (YOSHIMI_VERSION "1.5.10.1")
+add_definitions (-DMIN_CONFIG_MAJOR=1)
+add_definitions (-DMIN_CONFIG_MINOR=5)
 
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
@@ -76,7 +84,7 @@
 option (BuildForCore2_X86_64 "Build for Intel Core2 x86_64 system" OFF)
 option (BuildForNEON "Build for ARM Cortex A9 system" OFF)
 option (BuildForThisCPU "Build for presently running system" OFF)
-option (BuildForDebug "Include gdb debugging support" OFF)
+option (BuildForDebug "Debug build without optimisation. Enable gdb debugging support" OFF)
 
 #option to build lv2 plugin
 option (LV2Plugin "Build yoshimi lv2 plugin interface" ON)
@@ -84,40 +92,43 @@
 # developer info
 option (ShowGuiReports "Enable GUI control reports" OFF)
 option (ShowNoteOnTimes "Report Note-On Times" OFF)
+option (ReportNotes "Report Notes On/Off" OFF)
 
 
 set (BuildOptions_X86
-    "-O3 -msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer"
-    CACHE STRING "basic X86 complier options"
+    "-msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer"
+    CACHE STRING "basic X86 compiler options"
 )
 
 set (BuildOptions_X86_64AMD
-    "-O3 -march=athlon64 -m64 -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
+    "-march=athlon64 -m64 -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
   CACHE STRING "X86_64 compiler options"
 )
 
 set (BuildOptions_X86_64Core2
-    "-O3 -march=core2 -m64 -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
+    "-march=core2 -m64 -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
   CACHE STRING "X86_64 compiler options"
 )
 
 set (BuildOptions_NEON
-"-O3 -march=armv7-a -mfloat-abi=hard -mfpu=neon -mcpu=cortex-a9 -mtune=cortex-a9 -pipe -mvectorize-with-neon-quad -funsafe-loop-optimizations"
+    "-march=armv7-a -mfloat-abi=hard -mfpu=neon -mcpu=cortex-a9 -mtune=cortex-a9 -pipe -mvectorize-with-neon-quad -funsafe-loop-optimizations"
   CACHE STRING "Cortex_a9 compiler options"
 )
 
 set (BuildOptionsThisCPU
-    "-O3 -march=native -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
+    "-march=native -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
   CACHE STRING "Current CPU compiler options"
 )
 
 set (BuildOptionsBasic
-    "-O3 -ffast-math -fomit-frame-pointer"
+    "-ffast-math -fomit-frame-pointer"
     CACHE STRING "basic compilier options"
 )
 
 set (BuildOptionsDebug
-    "-O0 -g3 -ggdb -Wall -Wpointer-arith" CACHE STRING "Debug build flags")
+    "-O0 -g3 -ggdb -Wpointer-arith -Wpedantic -Wextra" CACHE STRING "Compile without optimisation and with debug information")
+set (BuildOptionsRelease
+    "-O3" CACHE STRING "Compile with optimisation for Release builds")
 
 find_package (PkgConfig REQUIRED)
 if (PKG_CONFIG_FOUND)
@@ -127,12 +138,6 @@
 endif (PKG_CONFIG_FOUND)
 
 include (CheckFunctionExists)
-# musl systems don’t have random_r() and also need argp-standalone
-check_function_exists(random_r randomR)
-
-if (randomR)
-    add_definitions(-DHAVE_RANDOM_R)
-endif(randomR)
 
 check_function_exists(exp10f EXP10F)
 
@@ -296,33 +301,38 @@
 
 set (YOSHI_INCLUDES ${FLTK_INCLUDE_DIR})
 
+# set platform specific compiler flags
+if (BuildFor0ld_X86)
+    set (OurCxxFlags ${BuildOptions_X86})
+else (BuildFor0ld_X86)
+    if (BuildForAMD_X86_64)
+        set (OurCxxFlags ${BuildOptions_X86_64AMD})
+    else (BuildForAMD_X86_64)
+        if (BuildForCore2_X86_64)
+            set (OurCxxFlags ${BuildOptions_X86_64Core2})
+        else (BuildForCore2_X86_64)
+            if (BuildForNEON)
+                set (OurCxxFlags ${BuildOptions_NEON})
+            else (BuildForNEON)
+                if (BuildForThisCPU)
+                    set (OurCxxFlags ${BuildOptionsThisCPU})
+                else (BuildForThisCPU)
+                    set (OurCxxFlags ${BuildOptionsBasic})
+                endif (BuildForThisCPU)
+            endif (BuildForNEON)
+        endif (BuildForCore2_X86_64)
+    endif (BuildForAMD_X86_64)
+endif (BuildFor0ld_X86)
+set (CMAKE_CXX_FLAGS "${OurCxxFlags} ${CMAKE_CXX_FLAGS}")
+
 if (BuildForDebug)
     set (CMAKE_BUILD_TYPE "Debug")
-    message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_DEBUG}")
+    set (CMAKE_CXX_FLAGS_DEBUG ${BuildOptionsDebug})
+    message (STATUS "DEBUG Build, flags: ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_DEBUG}")
 else (BuildForDebug)
     set (CMAKE_BUILD_TYPE "Release")
-    if (BuildFor0ld_X86)
-        set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_X86})
-    else (BuildFor0ld_X86)
-        if (BuildForAMD_X86_64)
-            set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_X86_64AMD})
-        else (BuildForAMD_X86_64)
-            if (BuildForCore2_X86_64)
-                set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_X86_64Core2})
-            else (BuildForCore2_X86_64)
-                if (BuildForNEON)
-                    set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_NEON})
-                else (BuildForNEON)
-                    if (BuildForThisCPU)
-                        set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsThisCPU})
-                    else (BuildForThisCPU)
-                        set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsBasic})
-                    endif (BuildForThisCPU)
-                endif (BuildForNEON)
-            endif (BuildForCore2_X86_64)
-        endif (BuildForAMD_X86_64)
-    endif (BuildFor0ld_X86)
-    message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_RELEASE}")
+    set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsRelease})
+    message (STATUS "RELEASE Build, flags: ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_RELEASE}")
 endif (BuildForDebug)
 
 configure_file(
@@ -343,7 +353,7 @@
 )
 
 set (Misc_sources
-    Misc/ConfBuild.cpp  Misc/Config.cpp  Misc/SynthEngine.cpp  Misc/Bank.cpp  Misc/Splash.cpp
+    Misc/Config.cpp  Misc/SynthEngine.cpp  Misc/Bank.cpp  Misc/Splash.cpp
     Misc/Microtonal.cpp   Misc/Part.cpp  Misc/XMLwrapper.cpp  Misc/MiscFuncs.cpp   Misc/WavFile.cpp
 )
 
@@ -359,7 +369,8 @@
     Params/ADnoteParameters.cpp  Params/EnvelopeParams.cpp
     Params/FilterParams.cpp  Params/LFOParams.cpp
     Params/SUBnoteParameters.cpp  Params/PADnoteParameters.cpp
-    Params/Controller.cpp  Params/Presets.cpp Params/PresetsStore.cpp
+    Params/Controller.cpp  Params/Presets.cpp
+    Params/PresetsStore.cpp  Params/UnifiedPresets.cpp
 )
 
 set (Synth_sources
@@ -376,14 +387,3 @@
     "PresetsUI" "EnvelopeUI"
     "LFOUI" "FilterUI" "VirKeyboardUI"
     "ConfigUI" "SUBnoteUI" "ResonanceUI"
-    "OscilGenUI" "ADnoteUI" "PADnoteUI"
-    "EffUI" "BankUI" "PartUI"
-    "MicrotonalUI" "MasterUI" "MasterMiscUI"
-    "ParametersUI" "ConsoleUI" "VectorUI"
-    "MidiLearnUI"
-)
-
-# workaround fltk_wrap_ui breakage
-set (FltkUI_sources)
-set (FltkUI_headers)
-foreach(basename ${FltkUI_names})
