=== debian/changelog ===
yoshimi (1.5.10.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.5.10.1
    * Refreshed debian/patches
  * Bumped standards verstion to 4.3.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 03 Feb 2019 13:31:36 +0100
